#!/usr/bin/python3

# copyright rene staritzbichler, 31.8.2020

import sys, os
from pdb2dat import convert


#######  SETTINGS :: ADJUST HERE ############
### mode and out_dir have to match!

mode = "sort_by_hydrophobicity"
#mode = "single"
#mode = "grouping"
#mode = "profile"

out_dir = "data_sorted/"
#out_dir = "data_hydrophob/"
#out_dir = "data_grouping/"
#out_dir = "data_profile/"  

pdb_dir = "pdb_format/"  # directory to read pdb files
cull = "cullpdb_pc50_res3.0_R1.0_d200828_chains29260"
##############################################


if not os.path.isdir( out_dir):
    os.mkdir( out_dir )

# read cull files    
with open( cull) as cf:
    cf.readline()
    # extract each pdb 
    for line in cf:
        # PDB-ID plus chain-ID in a single string
        pdb_with_chain = line.split()[0]
        print( pdb_with_chain)
        # path + filename of PDB file
        pdb = os.path.join( pdb_dir, pdb_with_chain[:-1].lower() + ".pdb")    
        chain = pdb_with_chain[-1]
        # output file that writes profiles and helix probability of one residue per line
        out = os.path.join( out_dir, pdb_with_chain.lower() + ".txt" )
        try:
            # extract AA sequence, translate into features,
            # extract helix definitions and write into single line
            convert( pdb, chain , out, mode)
        except:
            print("An exception occurred") 
            
                
