#!/usr/bin/python3

import sys, os

#######  SETTINGS :: ADJUST HERE ############
size = 3             # window size
half = int(size/2)
incr = 3

inpath = 'data_sorted/'  # adjust to output of convert.py script
##############################################

out = "db/div" + str(size) + '_' + str(incr) +'/'

# create output directories if missing
if not os.path.isdir('db'):
    os.mkdir( 'db')
if not os.path.isdir(out):
    os.mkdir( out)

# iterate through all files in input path    
for name in os.listdir(inpath):
    if ".txt" not in name: continue  

    # collect data from one file
    x = []
    y = []
    with open( os.path.join( inpath, name) ) as f:
        for l in f:
          c = l.split()
          x.append(c[:-1])  # descriptors/features
          y.append(c[-1])   # helix probability

    if len(x) < size:
        continue

    # write output into file with same name in output directory
    with open( os.path.join( out, name) , 'w') as w:
        # sliding window: center position, with half size on each side
        for i in range( half, len(x) - half, incr):
            # window for current center position
            seq = x[i-half:i+half+1]
            if len(seq) != size:
                print("WARNING!!")    
            # glue descriptors together: 'size' x 'nr of profile values per amino acid' 
            for j in range( 0, size):
                for s in seq[j]:
                    w.write(s+' ')
            # add helix probability of center amino acid as
            # helix probability for the window:
            w.write( y[i] + '\n')
            
    
