#!/usr/bin/python3

from sklearn.preprocessing import StandardScaler
from sklearn.neural_network import MLPRegressor
from sklearn.metrics import classification_report, confusion_matrix
from sklearn.model_selection import train_test_split
import os,sys, numpy as np, pickle


infile = "data.txt"
hidden = (10,15,10)  
iters  = 100        

steps = 10
delta = 0.01


print( "hidden: ", hidden, "iters", iters, "infile: ", infile)

x = []
y = []
with open( infile ) as f:
        for l in f:
                c = l.split()
                x.append( [ float(x) for x in c[:-1] ] )
                y.append( float(c[-1]) )

print( "data points: ", len(x), len(y))

print( "set up ANN")
ann = MLPRegressor( hidden_layer_sizes=hidden, max_iter=iters)


print( "training...")
sys.stdout.flush()

ann.fit( x, y)


print( "evaluate systematically ...")

error = 0
data = []
xs = []
sins = []

for x in np.arange( -50, 70, 0.1):
        v = []
        xx = x + 10 * delta
        xs.append( xx)
        sins.append( np.sin(xx))
        for i in range( 0, steps):
                v.append( np.sin( x + i * delta ) )
        data.append(v)

predictions = ann.predict(data)

error = 0
with open( "predicted.txt", 'w') as w:
        for x,y,z in zip( xs, predictions, sins):
                print( x, y, z, file=w)
                error += np.square( y-z)
print( "error:", np.sqrt( error / len(data)))

pickle.dump( ann, open('ann.pkl','wb'))

# nn = pickle.load(open('nn.pkl', 'rb'))
